unit Unit0036;

interface

uses
  Windows, Messages, SysUtils, Variants, Classes, Graphics, Controls, Forms,
  Dialogs, StdCtrls, ExtCtrls, Menus, ComCtrls,
  UnitIni, Unit0036va, Unit0036a ;

type
  TForm1 = class(TForm)
    MainMenu1: TMainMenu;
    File1: TMenuItem;
    MnuExit: TMenuItem;
    Show1: TMenuItem;
    MnuWindDisp: TMenuItem;
    N1: TMenuItem;
    MnuMoMove1: TMenuItem;
    MnuMoMove2: TMenuItem;
    MnuMoMove3: TMenuItem;
    Panel1: TPanel;
    Label1: TLabel;
    Label2: TLabel;
    Label3: TLabel;
    Label4: TLabel;
    Edit1: TEdit;
    Edit2: TEdit;
    Edit3: TEdit;
    Button10: TButton;
    Button11: TButton;
    Button12: TButton;
    Button13: TButton;
    Panel2: TPanel;
    PaintBox1: TPaintBox;
    ScrollBar1: TScrollBar;
    ScrollBar2: TScrollBar;
    Panel3: TPanel;
    Panel4: TPanel;
    StatusBar1: TStatusBar;
    LabelA1: TLabel;
    LabelA2: TLabel;
    LabelA3: TLabel;
    procedure FormShow(Sender: TObject);
    procedure PaintBox1Paint(Sender: TObject);
    procedure MnuExitClick(Sender: TObject);
    procedure MnuWindDispClick(Sender: TObject);
    procedure MnuMoMove1Click(Sender: TObject);
    procedure MnuMoMove2Click(Sender: TObject);
    procedure MnuMoMove3Click(Sender: TObject);
    procedure ScrollBar1Change(Sender: TObject);
    procedure ScrollBar2Change(Sender: TObject);
    procedure Button10Click(Sender: TObject);
    procedure Button11Click(Sender: TObject);
    procedure Button12Click(Sender: TObject);
    procedure Button13Click(Sender: TObject);
    procedure FormKeyDown(Sender: TObject; var Key: Word;
      Shift: TShiftState);
    procedure PaintBox1MouseDown(Sender: TObject; Button: TMouseButton;
      Shift: TShiftState; X, Y: Integer);
    procedure PaintBox1MouseMove(Sender: TObject; Shift: TShiftState; X,
      Y: Integer);
    procedure PaintBox1MouseUp(Sender: TObject; Button: TMouseButton;
      Shift: TShiftState; X, Y: Integer);
    procedure FormResize(Sender: TObject);
    procedure FormClose(Sender: TObject; var Action: TCloseAction);
  private
    { Private 錾 }
    Fmode : Integer ;         // @\[h
    FBx,FBy : Double ;        // @\s̍ۂɋLwW
    RBflag : Boolean ;        // o[oh\tO True:\ False:\
    RBx1,RBy1 : Integer ;     // o[ohJn_
    RBx2,RBy2 : Integer ;     // o[ohI_
    DRGx1,DRGy1 : Integer ;   // hbOJn_
    DRGx2,DRGy2 : Integer ;   // hbOI_
    DRGmode : Integer ;       // hbO[h 0:ړ 1:g(SHIFT) 2:k(CTRL)
    DRGflag : Boolean ;       // hbOǂ̃tO
    DRGRBflag : Boolean ;     // hbÕo[oh\tO
    procedure MouseClick(X,Y:Integer);
    procedure GRBLINE(rx1,ry1,rx2,ry2:Integer); // o[oh`
    procedure GRBBOX(rx1,ry1,rx2,ry2:Integer);  // o[oh``
    procedure GRB_ERASE;   // o[oh
  public
    { Public 錾 }
    procedure GCLS ;    // ʃNA
    procedure GDRAW ;   // ʍ}
    procedure GALDRAW ; // ʕ\
    procedure GREDRAW ; // ʍč}
    procedure COM_DISPMOVE ;     // ʈړ
    procedure COM_DISPZOOM1 ;    // Q{\
    procedure COM_DISPZOOM2 ;    // 1/2{k
    procedure COM_DRAWLINE1 ;    // }
  end;

var
  Form1: TForm1;

implementation

{$R *.dfm}

// 
procedure TForm1.FormShow(Sender: TObject);
var
   p1,p2 : double ;
   inif,s : String ;
begin
   Fmode := 0 ;
   RBflag := False ;
   FBx := 0.0;
   FBy := 0.0;
   DRGflag := False ;
   DRGRBflag := False ;
   Dat_N := 0 ;      // f[^
   PA_x := StrToFloat(Edit1.Text);
   PA_y := StrToFloat(Edit2.Text);
   SC_x := PaintBox1.Width ;
   SC_y := PaintBox1.Height ;
   p1 := SC_x / PA_x ;
   p2 := SC_y / PA_y ;
   if (p1 < p2) then MM_dot := p1 else MM_dot := p2 ;
   MM_dotmax := MM_dot ;
   IN_move := 50 ;   // ʈړ(ini/inp)
   IN_scale:= 1.0 ;  // Cӊg(ini/inp)
   GALDRAW ;

   { INI Fileǂ }
   AppPath := ExtractFilePath(Application.ExeName);
   inif := AppPath + 'test.ini' ;
	if (ReadIniFile('Form','F01_X',s,inif,9)) then Form1.Left   := StrToInt(s);
	if (ReadIniFile('Form','F01_Y',s,inif,9)) then Form1.Top    := StrToInt(s);
	if (ReadIniFile('Form','F01_W',s,inif,9)) then Form1.Width  := StrToInt(s);
	if (ReadIniFile('Form','F01_H',s,inif,9)) then Form1.Height := StrToInt(s);
	if (ReadIniFile('Form','F02_X',s,inif,9)) then FmWindowPal.Left:= StrToInt(s);
	if (ReadIniFile('Form','F02_Y',s,inif,9)) then FmWindowPal.Top := StrToInt(s);
end;

// vOI
procedure TForm1.FormClose(Sender: TObject; var Action: TCloseAction);
var
   i1,i2,i3,i4,i5,i6 : integer ;
   inif : String ;
begin
   Dat := nil ;         // f[^̈

   { INI File }
   inif := AppPath + 'test.ini' ;
	i1 := Form1.Left ;
   i2 := Form1.Top ;
	i3 := Form1.Width ;
   i4 := Form1.Height ;
	i5 := FmWindowPal.Left ;
   i6 := FmWindowPal.Top ;
	try
	   WriteIniFile('Form','F01_X',IntToStr(i1) ,inif);
   	WriteIniFile('Form','F01_Y',IntToStr(i2) ,inif);
	   WriteIniFile('Form','F01_W',IntToStr(i3) ,inif);
   	WriteIniFile('Form','F01_H',IntToStr(i4) ,inif);
	   WriteIniFile('Form','F02_X',IntToStr(i5) ,inif);
   	WriteIniFile('Form','F02_Y',IntToStr(i6) ,inif);
	except
   	;
   end;
end;

// ʂNA
procedure TForm1.GCLS ;
begin
   with PaintBox1.Canvas do begin
      // ʂ
      with Pen do begin
         Mode  := pmCopy ;
         Color := clWhite;
         Style := psSolid;
         Width := 1;
      end;
      with Brush do begin
         Color := clWhite;
         Style := bsSolid;
      end;
      Rectangle(0,0,SC_x,SC_y);
   end;
end;

// ʂ}
procedure TForm1.GDRAW ;
var
   ax1,ay1,ax2,ay2 : Integer ;
   i : integer ;
begin
   with PaintBox1.Canvas do begin
      // pg
      ax1 := Round( ( -PA_x/2 - WD_x1 ) * MM_dot );
      ay1 := Round(-( -PA_y/2 - WD_y2 ) * MM_dot );
      ax2 := Round( (  PA_x/2 - WD_x1 ) * MM_dot );
      ay2 := Round(-(  PA_y/2 - WD_y2 ) * MM_dot );
      Pen.Mode  := pmCopy ;
      Pen.Color := clBlue ;
      Brush.Style := bsClear ;
      Rectangle(ax1,ay1,ax2,ay2);
      // _
      ax1 := Round( ( 0.0 - WD_x1 ) * MM_dot );
      ay1 := Round(-( 0.0 - WD_y2 ) * MM_dot );
      Pen.Color := clRed ;
      MoveTo(ax1-5,ay1);   LineTo(ax1+6,ay1);
      MoveTo(ax1,ay1-5);   LineTo(ax1,ay1+6);
      // vf`
      Pen.Color := clBlack ;
      for i:=0 to Dat_N-1 do begin
         ax1 := Round( (Dat[i].x1 - WD_x1 ) * MM_dot );
         ay1 := Round(-(Dat[i].y1 - WD_y2 ) * MM_dot );
         ax2 := Round( (Dat[i].x2 - WD_x1 ) * MM_dot );
         ay2 := Round(-(Dat[i].y2 - WD_y2 ) * MM_dot );
         MoveTo(ax1,ay1);
         LineTo(ax2,ay2);
      end;
   end;
   //
   RBx1 := Round( ( FBx - WD_x1 ) * MM_dot );   // ČvZ
   RBy1 := Round(-( FBy - WD_y2 ) * MM_dot );
   if (RBflag) then begin
      RBflag := False ; // o[oh͏Ă̂
   end;
end;

// ʕ\
procedure TForm1.GALDRAW ;
begin
   GCLS ;   // ʂNA
   MM_dot := MM_dotmax ;
   WD_x1 := - SC_x / 2.0 / MM_dot ;
   WD_y1 := - SC_y / 2.0 / MM_dot ;
   WD_x2 :=   SC_x / 2.0 / MM_dot ;
   WD_y2 :=   SC_y / 2.0 / MM_dot ;
   Edit3.Text := FloatToStr(MM_dot);
   LabelA1.Caption := '( '+FloatToStr(WD_x1)+' , '+FloatToStr(WD_y1)+' )';
   LabelA2.Caption := '( '+FloatToStr(WD_x2)+' , '+FloatToStr(WD_y2)+' )';
   GDRAW ;  // ʂ}
end;

// ʂč}
procedure TForm1.GREDRAW ;
begin
   GCLS ;   // ʂNA
   Edit3.Text := FloatToStr(MM_dot);
   LabelA1.Caption := '( '+FloatToStr(WD_x1)+' , '+FloatToStr(WD_y1)+' )';
   LabelA2.Caption := '( '+FloatToStr(WD_x2)+' , '+FloatToStr(WD_y2)+' )';
   GDRAW ;  // ʂ}
end;

// o[oh`
procedure TForm1.GRBLINE(rx1,ry1,rx2,ry2:Integer);
begin
   with PaintBox1.Canvas do begin
      Pen.Mode := pmXor ;
      Pen.Color := clAqua ;
      Pen.Width := 0 ;
      Pen.Style := psSolid ;
      MoveTo(rx1,ry1);
      LineTo(rx2,ry2);
   end;
end;

// o[oh``
procedure TForm1.GRBBOX(rx1,ry1,rx2,ry2:Integer);
begin
   with PaintBox1.Canvas do begin
      Pen.Mode := pmXor ;
      Pen.Color := clAqua ;
      Pen.Width := 0 ;
      Pen.Style := psSolid ;
      Brush.Style := bsClear ;
      Rectangle(rx1,ry1,rx2,ry2);
   end;
end;

// o[oh
procedure TForm1.GRB_ERASE;
begin
   if (RBflag) then begin
      Case (Fmode) of
      101:begin
            GRBLINE(RBx1,RBy1,RBx2,RBy2);
         end;
      end;
      RBflag := False ;
   end;
end;

// ʂĕ`
procedure TForm1.PaintBox1Paint(Sender: TObject);
begin
   GREDRAW ;  // ʍč}
end;

// ʂTCYꂽČvZ
procedure TForm1.FormResize(Sender: TObject);
var
   p1,p2 : double ;
begin
   SC_x := PaintBox1.Width ;
   SC_y := PaintBox1.Height ;
   p1 := SC_x / PA_x ;
   p2 := SC_y / PA_y ;
   if (p1 < p2) then MM_dotmax := p1 else MM_dotmax := p2 ;
   WD_x1 := - SC_x / 2.0 / MM_dot ;
   WD_y1 := - SC_y / 2.0 / MM_dot ;
   WD_x2 :=   SC_x / 2.0 / MM_dot ;
   WD_y2 :=   SC_y / 2.0 / MM_dot ;
   // ̌PaintBoxOnPaintCxg܂̂
   // č}͂ɔC܂
end;

// ========== ========== ========== ==========
//                 j[
// ========== ========== ========== ==========

// j[bt@CbI
procedure TForm1.MnuExitClick(Sender: TObject);
begin
   close ;
end;

// j[b\bEChEpbg
procedure TForm1.MnuWindDispClick(Sender: TObject);
begin
   FmWindowPal.Show ;
end;

// j[b\b}EXŉʈړ
procedure TForm1.MnuMoMove1Click(Sender: TObject);
begin
   COM_DISPMOVE ;
end;

// j[b\b}EXłQ{g
procedure TForm1.MnuMoMove2Click(Sender: TObject);
begin
   COM_DISPZOOM1 ;
end;

// j[b\b}EX1/2{k
procedure TForm1.MnuMoMove3Click(Sender: TObject);
begin
   COM_DISPZOOM2 ;
end;

// ========== ========== ========== ==========
//                 {^
// ========== ========== ========== ==========

// XN[o[ňړ
procedure TForm1.ScrollBar1Change(Sender: TObject);
var
   p : double ;
begin
   p := PA_x/2.0 * ScrollBar1.Position/100.0 ;
   WD_x1 := - SC_x / 2.0 / MM_dot + p ;
   WD_x2 :=   SC_x / 2.0 / MM_dot + p ;
   GREDRAW ;  // ʍč}
end;

// XN[o[ňړ
procedure TForm1.ScrollBar2Change(Sender: TObject);
var
   p : double ;
begin
   p := - PA_y/2.0 * ScrollBar2.Position/100.0 ;
   WD_y1 := - SC_y / 2.0 / MM_dot + p ;
   WD_y2 :=   SC_y / 2.0 / MM_dot + p ;
   GREDRAW ;  // ʍč}
end;

// }EXŉʈړ
procedure TForm1.Button10Click(Sender: TObject);
begin
   COM_DISPMOVE;
end;

// }EXłQ{g
procedure TForm1.Button11Click(Sender: TObject);
begin
   COM_DISPZOOM1 ;
end;

// }EX1/2{k
procedure TForm1.Button12Click(Sender: TObject);
begin
   COM_DISPZOOM2 ;
end;

// }
procedure TForm1.Button13Click(Sender: TObject);
begin
   COM_DRAWLINE1 ;
end;

// ========== ========== ========== ==========
//              R}hڍs
// ========== ========== ========== ==========

// }EXŉʈړ
procedure TForm1.COM_DISPMOVE ;
begin
   Fmode := 1 ;
   StatusBar1.Panels[0].Text := '}EXʈړ';
   StatusBar1.Panels[1].Text := '';
   StatusBar1.Panels[2].Text := 'ʈړ_wĉ';
end;

// }EXłQ{g
procedure TForm1.COM_DISPZOOM1 ;
begin
   Fmode := 2 ;
   StatusBar1.Panels[0].Text := '}EXQ{g';
   StatusBar1.Panels[1].Text := '';
   StatusBar1.Panels[2].Text := 'ʒS_wĉ';
end;

// }EX1/2{k
procedure TForm1.COM_DISPZOOM2 ;
begin
   Fmode := 3 ;
   StatusBar1.Panels[0].Text := '}EX1/2{k';
   StatusBar1.Panels[1].Text := '';
   StatusBar1.Panels[2].Text := 'ʒS_wĉ';
end;

// }
procedure TForm1.COM_DRAWLINE1 ;
begin
   GRB_ERASE ;
   Fmode := 100 ;
   StatusBar1.Panels[0].Text := '';
   StatusBar1.Panels[1].Text := 'Q_w';
   StatusBar1.Panels[2].Text := 'Jn_wĉ';
end;

// ========== ========== ========== ==========
//                   L[
// ========== ========== ========== ==========

// L[ĉʈړ
procedure TForm1.FormKeyDown(Sender: TObject; var Key: Word;
  Shift: TShiftState);
begin
   if (Key = VK_UP) then begin
      WD_y1 := WD_y1 + IN_move ;
      WD_y2 := WD_y2 + IN_move ;
      GREDRAW ;
      Key := 0 ;
   end
   else if (Key = VK_DOWN) then begin
      WD_y1 := WD_y1 - IN_move ;
      WD_y2 := WD_y2 - IN_move ;
      GREDRAW ;
      Key := 0 ;
   end
   else if (Key = VK_LEFT) then begin
      WD_x1 := WD_x1 - IN_move ;
      WD_x2 := WD_x2 - IN_move ;
      GREDRAW ;
      Key := 0 ;
   end
   else if (Key = VK_RIGHT) then begin
      WD_x1 := WD_x1 + IN_move ;
      WD_x2 := WD_x2 + IN_move ;
      GREDRAW ;
      Key := 0 ;
   end
   else if (Key = VK_HOME) then begin
      WD_x1 := - SC_x / 2.0 / MM_dot ;
      WD_y1 := - SC_y / 2.0 / MM_dot ;
      WD_x2 :=   SC_x / 2.0 / MM_dot ;
      WD_y2 :=   SC_y / 2.0 / MM_dot ;
      GREDRAW ;
      Key := 0 ;
   end;
end;

// ========== ========== ========== ==========
//                 }EX
// ========== ========== ========== ==========

// }EX{^̏
procedure TForm1.PaintBox1MouseDown(Sender: TObject; Button: TMouseButton;
  Shift: TShiftState; X, Y: Integer);
begin
   if (ssLeft in Shift)or(ssRight in Shift) then begin  // NbN
      DRGflag := True ;
      DRGx1 := X ;
      DRGy1 := Y ;
      DRGRBflag := False ;
      DRGx2 := 0 ;
      DRGy2 := 0 ;
      if (ssLeft  in Shift) then DRGx2 := 1 ;
      if (ssRight in Shift) then DRGy2 := 1 ;
   end;
end;

// }EX𓮂
procedure TForm1.PaintBox1MouseMove(Sender: TObject; Shift: TShiftState; X,
  Y: Integer);
var
   tx,ty : double ;
begin
   tx := WD_x1 + X / MM_dot ;
   ty := WD_y2 - Y / MM_dot ;
   LabelA3.Caption := '( '+FloatToStr(tx)+' , '+FloatToStr(ty)+' )';
   //
   if (DRGflag) then begin // EhbO
      if (DRGRBflag) then begin
         GRBBOX(DRGx1,DRGy1,DRGx2,DRGy2);
      end;
      if (ssLeft in Shift)and(ssRight in Shift) then begin
         GRBBOX(DRGx1,DRGy1,X,Y);
         DRGRBflag := True ;
         DRGx2 := X ;
         DRGy2 := Y ;
      end
      else begin
         DRGRBflag := False ;
         if (ssLeft  in Shift) then DRGx2 := 1 ;
         if (ssRight in Shift) then DRGy2 := 1 ;
      end;
   end
   else begin  // }EXړ
      Case (Fmode) of
      101:begin   // bI_w
            GRB_ERASE ;
            GRBLINE(RBx1,RBy1,X,Y); // Vo[oh`
            RBflag := True ;
            RBx2 := X ;
            RBy2 := Y ;
         end;
      end;
   end;
end;

// }EX{^𗣂̏
procedure TForm1.PaintBox1MouseUp(Sender: TObject; Button: TMouseButton;
  Shift: TShiftState; X, Y: Integer);
var
   xx1,yy1,xx2,yy2 : double ;
   cx,cy : double ;
   dx,dy : double ;
   bx,by : double ;
   p1,p2 : Double ;
begin
   if not(DRGRBflag)and((DRGx2 = 0)or(DRGy2 = 0)) then begin
      DRGflag := False ;
      if (DRGx2 = 1) then begin    // NbN
         // NbN
         MessageBeep(Word(-1));
         MouseClick(X,Y);
      end
      else if (DRGy2 = 1) then begin    // ENbN
         // Xibv
         MessageBeep(Word(-1));
         MouseClick(X,Y);
      end;
      exit;
   end;

   if (DRGflag) then begin
      // hbO
      DRGflag := False ;
      if (DRGRBflag) then begin
         GRBBOX(DRGx1,DRGy1,DRGx2,DRGy2);
      end;
      if (Abs(DRGx1-X) <= 5)and(Abs(DRGy1-Y) <= 5) then
         DRGmode := 0
      else begin
         if (DRGx1 <= X) then
            DRGmode := 1
         else
            DRGmode := 2;
      end;
      xx1 := WD_x1 + DRGx1 / MM_dot ;
      yy1 := WD_y2 - DRGy1 / MM_dot ;
      xx2 := WD_x1 + X / MM_dot ;
      yy2 := WD_y2 - Y / MM_dot ;
      dx := Abs(WD_x2-WD_x1) ;   // ݂̃r[̑傫
      dy := Abs(WD_y2-WD_y1) ;   // Abs͕KvǈꉞĂ
      bx := Abs(xx1-xx2);  // `̑傫
      by := Abs(yy1-yy2);
      cx := (xx1+xx2)/2.0; // `̒̍W
      cy := (yy1+yy2)/2.0;
      Case (DRGmode) of
      0: begin    // ړ
            cx := (WD_x1+WD_x2)/2.0 ;  // ݂̒̍W
            cy := (WD_y1+WD_y2)/2.0 ;
            dx := xx2 - cx ;      // ړ
            dy := yy2 - cy ;
            WD_x1 := WD_x1 + dx ;      // ړvZ
            WD_y1 := WD_y1 + dy ;
            WD_x2 := WD_x2 + dx ;
            WD_y2 := WD_y2 + dy ;
            GREDRAW ;   // ʍč}
         end;
      1: begin    // g
            if (bx < 0.000001) then bx:=0.000001;
            if (by < 0.000001) then by:=0.000001;
            p1 := dx / bx ;         // ݂̉ʂɑ΂ĉ{H
            p2 := dy / by ;
            if (p1 < p2) then MM_dot := MM_dot*p1 else MM_dot := MM_dot*p2 ;
            Edit3.Text := FloatToStr(MM_dot);
            WD_x1 := cx - SC_x / 2.0 / MM_dot ;   // r[GAvZ
            WD_y1 := cy - SC_y / 2.0 / MM_dot ;
            WD_x2 := cx + SC_x / 2.0 / MM_dot ;
            WD_y2 := cy + SC_y / 2.0 / MM_dot ;
            GREDRAW ;   // ʍč}
         end;
      2: begin    // k
            p1 := bx / dx ;         // ݂̉ʂ牽{H
            p2 := by / dy ;
            if (p1 > p2) then MM_dot := MM_dot*p1 else MM_dot := MM_dot*p2 ;
            if (MM_dot < MM_dotmax) then MM_dot := MM_dotmax ;
            Edit3.Text := FloatToStr(MM_dot);
            WD_x1 := cx - SC_x / 2.0 / MM_dot ;   // r[GAvZ
            WD_y1 := cy - SC_y / 2.0 / MM_dot ;
            WD_x2 := cx + SC_x / 2.0 / MM_dot ;
            WD_y2 := cy + SC_y / 2.0 / MM_dot ;
            GREDRAW ;   // ʍč}
         end;
      end;
   end
end;

// }EXNbN
procedure TForm1.MouseClick(X,Y:Integer);
var
   cx,cy : double ;
   tx,ty : double ;
   dx,dy : double ;
begin
   cx := (WD_x1+WD_x2)/2.0 ;  // ݂̒̍W
   cy := (WD_y1+WD_y2)/2.0 ;
   dx := Abs(WD_x2-WD_x1) ;   // ݂̃r[̑傫
   dy := Abs(WD_y2-WD_y1) ;   // Abs͕KvǈꉞĂ
   tx := WD_x1 + X / MM_dot ; // NbNW
   ty := WD_y2 - Y / MM_dot ;
   Case (Fmode) of
   1: begin // ʈړ
         dx := tx - cx ;      // ړ
         dy := ty - cy ;
         WD_x1 := WD_x1 + dx ;      // ړvZ
         WD_y1 := WD_y1 + dy ;
         WD_x2 := WD_x2 + dx ;
         WD_y2 := WD_y2 + dy ;
         GREDRAW ;   // ʍč}
      end;
   2: begin // Q{g
         MM_dot := MM_dot * 2.0 ;
         Edit3.Text := FloatToStr(MM_dot);
         WD_x1 := tx - dx/4.0;   // g偁r[1/2ɏȂ
         WD_y1 := ty - dy/4.0;
         WD_x2 := tx + dx/4.0;
         WD_y2 := ty + dy/4.0;
         GREDRAW ;  // ʍč}
      end;
   3: begin // 1/2{k
         MM_dot := MM_dot * 0.5 ;
         Edit3.Text := FloatToStr(MM_dot);
         WD_x1 := tx - dx;       // kr[1/2ɏȂ
         WD_y1 := ty - dy;
         WD_x2 := tx + dx;
         WD_y2 := ty + dy;
         GREDRAW ;  // ʍč}
      end;
   100:begin // bJn_
         FBx := tx ;
         FBy := ty ;
         Fmode := 101 ;
         StatusBar1.Panels[2].Text := 'I_wĉ';
         RBflag := False ;
         RBx1 := X ;
         RBy1 := Y ;
      end;
   101:begin // bI_
         if (Abs(FBx-tx) > 0.00000001)or(Abs(FBy-ty) > 0.00000001) then begin
            GRB_ERASE ;
            // f[^o^
            Inc(Dat_N);
            try
               SetLength(Dat,Dat_N);   // f[^̈𑝂₷
               Dat[Dat_N-1].x1 := FBx ;   // Y 0 Ȃ̂Œ
               Dat[Dat_N-1].y1 := FBy ;
               Dat[Dat_N-1].x2 := tx ;
               Dat[Dat_N-1].y2 := ty ;
            except
               Dec(Dat_N);
               MessageBeep(Word(-1));
               MessageDlg('ȏf[^o^鎖͏o܂B',
                  mtError, [mbOk], 0);
            end;
            GREDRAW ;   // ʍč}
            Fmode := 100 ;
            StatusBar1.Panels[2].Text := 'Jn_wĉ';
         end;
      end;
   end;
end;


end.
